ALTER TABLE KUPCI
ADD MANAGER VARCHAR2(20 CHAR);

CREATE OR REPLACE VIEW V_KUPCIBELEZKE AS (
SELECT KB.ID_KPBELEZKE, KB.IDKUPCA, KB.DATUMKREIRANJA, KB.USERKREIRANJA, KB.BELEZKA, KB.VELJAVNA, KB.TYPE, KB.SUBTYPE,
KBT.OPIS AS BELEZKE_TYPE_OPIS, KBT.INTERNI_OPIS AS BELEZKE_TYPE_INTERNI_OPIS, KBS.OPIS AS BELEZKE_SUBTYPE_OPIS, KBS.INTERNI_OPIS AS BELEZKE_SUBTYPE_INTERNI_OPIS,
K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.MANAGER AS KUPCI_MANAGER, K.VRSTA AS KUPCI_VRSTA
FROM KUPCIBELEZKE KB
LEFT OUTER JOIN NKUPCIBELEZKE_TYPE KBT ON KBT.ID = KB.TYPE
LEFT OUTER JOIN NKUPCIBELEZKE_SUBTYPE KBS ON KBS.ID = KB.SUBTYPE
LEFT OUTER JOIN KUPCI K ON K.ID = KB.IDKUPCA
);

CREATE OR REPLACE VIEW V_PLOVILABELEZKE AS (
SELECT PB.ID_PLBELEZKE, PB.IDPLOVILA, PB.ID_PRIVEZ, PB.DATUMKREIRANJA, PB.USERKREIRANJA, PB.BELEZKA, PB.VELJAVNA, PB.TYPE, PB.SUBTYPE,
PBT.OPIS AS BELEZKE_TYPE_OPIS, PBT.INTERNI_OPIS AS BELEZKE_TYPE_INTERNI_OPIS, PBS.OPIS AS BELEZKE_SUBTYPE_OPIS, PBS.INTERNI_OPIS AS BELEZKE_SUBTYPE_INTERNI_OPIS, 
PL.IME AS PLOVILA_IME, K.ID AS KUPCI_ID, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.MANAGER AS KUPCI_MANAGER, K.VRSTA AS KUPCI_VRSTA, 
NP.OBJEKT AS NNPRIVEZ_OBJEKT, NP.N_PRIVEZA AS NNPRIVEZ_PRIVEZ
FROM PLOVILABELEZKE PB
LEFT OUTER JOIN NPLOVILABELEZKE_TYPE PBT ON PBT.ID = PB.TYPE
LEFT OUTER JOIN NPLOVILABELEZKE_SUBTYPE PBS ON PBS.ID = PB.SUBTYPE
LEFT OUTER JOIN PLOVILA PL ON PL.ID = PB.IDPLOVILA
LEFT OUTER JOIN KUPCI K ON K.ID = PL.ID_LASTNIKA
LEFT OUTER JOIN NNPRIVEZ NP ON NP.ID_PRIVEZ = PB.ID_PRIVEZ
);

CREATE OR REPLACE VIEW V_KUPCI_EMAIL
AS (
SELECT O.ID_OPOMINI AS ID, O.LASTNIK_OBVESCEN, K.ID AS KUPCI_ID, K.PRIIMEK AS KUPCI_PRIIMEK, K.IME AS KUPCI_IME, K.ID_MEMBER AS KUPCI_ID_MEMBER, K.MANAGER AS KUPCI_MANAGER, K.VRSTA AS KUPCI_VRSTA, 
E.ID_EMAIL AS EMAIL_ID_EMAIL, E.DATUM_KREIRANJA AS EMAIL_DATUM_KREIRANJA, E.USER_KREIRANJA AS EMAIL_USER_KREIRANJA,
E.TEKST AS EMAIL_TEKST, E.ZADEVA AS EMAIL_ZADEVA, E.POSILJATELJ AS EMAIL_POSILJATELJ, E.PREJEMNIK AS EMAIL_PREJEMNIK, E.STATUS AS EMAIL_STATUS, E.DATUM_POSILJANJA AS EMAIL_DATUM_POSILJANJA, E.AVTOMATSKO_KREIRANJE
AS EMAIL_AVTOMATSKO_KREIRANJE, E.PREJEMNIK_CC AS EMAIL_PREJEMNIK_CC, E.PREJEMNIK_BCC AS EMAIL_PREJEMNIK_BCC, E.PREBRANO AS EMAIL_PREBRANO, E.STATUS_MESSAGE AS EMAIL_STATUS_MESSAGE
FROM OPOMINI O
LEFT OUTER JOIN KUPCI K ON K.ID = O.ID_KUPCA
LEFT OUTER JOIN EMAILS E ON E.ID_EMAIL = O.ID_EMAIL
WHERE O.NPISMO = (SELECT NPISMO FROM NPISMO N WHERE N.NPISMO_TYPE = 'EMAIL')
);

CREATE OR REPLACE VIEW V_SMS
AS (
SELECT S.ID, S.RECEIVER, S.CONTENT, S.STATUS, S.SMS_FILE, S.DATE_CREATED, S.USER_CREATED, S.STATUS_MESSAGE,
K.ID AS KUPCI_ID, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.MANAGER AS KUPCI_MANAGER, K.VRSTA AS KUPCI_VRSTA
FROM SMS S
LEFT OUTER JOIN (SELECT ID_KUPCA, ID_SMS, NPISMO, RANK() OVER (PARTITION BY ID_SMS ORDER BY ID_OPOMINI ASC) RNK FROM OPOMINI) O ON (O.ID_SMS = S.ID AND O.RNK = 1 AND O.NPISMO = 'S')
LEFT OUTER JOIN KUPCI K ON O.ID_KUPCA = K.ID
);

CREATE OR REPLACE VIEW V_KUPCI_ACTIVITY
AS (
SELECT KA.ID_KUPCI_ACTIVITY, K.ID AS KUPCI_ID, K.PRIIMEK AS KUPCI_PRIIMEK, K.IME AS KUPCI_IME, K.ID_MEMBER AS KUPCI_ID_MEMBER, K.MANAGER AS KUPCI_MANAGER, K.VRSTA AS KUPCI_VRSTA,
A.ID_ACTIVITY AS ID_ACTIVITY, A.DATE_FROM AS ACTIVITY_DATE_FROM, A.DATE_TO AS ACTIVITY_DATE_TO, A.ACTIVITY_TYPE, A.DESCRIPTION AS ACTIVITY_DESCRIPTION, A.STATUS AS ACTIVITY_STATUS,
A.DATE_CREATED AS ACTIVITY_DATE_CREATED, A.USER_CREATED AS ACTIVITY_USER_CREATED, A.DATE_CHANGED AS ACTIVITY_DATE_CHANGED, A.USER_CHANGED AS ACTIVITY_USER_CHANGED, A.COMPLETED AS ACTIVITY_COMPLETED, 
A.AUTO_CREATE AS ACTIVITY_AUTO_CREATE, A.SOURCE AS ACTIVITY_SOURCE, AT.OPIS AS ACTIVITY_TYPE_OPIS, AT.INTERNI_OPIS AS ACTIVITY_TYPE_INTERNI_OPIS, AT.AKT AS ACTIVITY_TYPE_AKT
FROM KUPCI_ACTIVITY KA
JOIN KUPCI K ON K.ID = KA.ID_KUPCA
JOIN ACTIVITY A ON A.ID_ACTIVITY = KA.ID_ACTIVITY
LEFT OUTER JOIN NNACTIVITY_TYPE AT ON AT.ID_NNACTIVITY_TYPE = A.ACTIVITY_TYPE
);

CREATE OR REPLACE VIEW V_STORITVE AS (
	SELECT M.ID_STORITVE, M.ID_DN, M.ID_POGODBE, M.ID_VPS, M.VRSTA, M.ID_LASTNIKA, M.ID_PLOVILA, M.STORITEV, M.KAT, M.TIMEKAT, M.PROCKAT, M.DATUM_OD, M.DATUM_DO, M.KOLICINA, M.POPUST, M.OPIS_SERVIS,
  M.ZNESEK, M.VALUTA, M.TECAJ, M.DAVEK, M.N_PONUDBE, M.N_RACUNA, M.DATUM_RACUNA, M.ZAKLJUCEN, M.KOMENTAR, M.DATUM_KREIRANJA, M.USER_KREIRANJA, M.DATUM_SPREMEMBE, M.USER_SPREMEMBE, M.TIP_SERVIS, M.AUTO,
  M.POPUST1, M.POPUST2, M.NAMENP, M.NAMENP1, M.NAMENP2, M.TECAJP, M.DODATNA_STORITEV, M.DOMACA_VALUTA, M.PROVIZIJA, M.DRZAVA, M.SKUPAJ_OSEB, M.ID_KAT, M.PROVIZIJA_DELITEV, M.ID_REZERVACIJE, M.CUSTOM,
  M.CPROVIZIJA, M.SERVICE_COST, M.COMPLETE, M.KOLICINA_INSTR, M.ID_STORITVE_GEN, M.ID_BATCH, M.ID_SALDKONT, M.ID_LASTNIKA_ORG, M.NNLOCATION_ID, M.MIN_FEE, M.ID_LASTNIK_LEASE, 
  M.NCARD, M.FULL_AMOUNT, M.SERVICE_TIME, M.ID_PRIVEZ, M.SUBLEASE_PAYMENT, M.ID_DAVEK, M.LASTNIK_LEASE_PROCENT, M.ID_REZERVACIJE_CHARTER, M.ID_SERVICE_TEMPLATE, M.CAS_OD, M.CAS_DO, M.USER_COMMENT, M.SERVICE_COMMENT,
  M.ID_OWNER_SIGNATURE,
  NS.OPIS AS NNSTOMAR_OPIS, NS.INTERNI_OPIS AS NNSTOMAR_INTERNI_OPIS, NS.DAVEK AS NNSTOMAR_DAVEK, NS.KAT AS NNSTOMAR_KAT, NS.TIMEKAT AS NNSTOMAR_TIMEKAT, NS.ENOTA AS NNSTOMAR_ENOTA, NS.FILTER AS NNSTOMAR_FILTER,
  NS.DEPARTURE_CHECK AS NNSTOMAR_DEPARTURE_CHECK,
  NNE.OPIS AS NNSTOMAR_ENOTA_OPIS, NNE.INTERNI_OPIS AS NNSTOMAR_ENOTA_INTERNI_OPIS, MDN.DATUM_DN AS M_DE_NA_DATUM_DN, MDN.TERMIN_DO AS M_DE_NA_TERMIN_DO, MDN.STEVILKA AS M_DE_NA_STEVILKA,
  MDN.STATUS AS M_DE_NA_STATUS, MDN.ORG_STATUS AS M_DE_NA_ORG_STATUS, 
  KU.IME AS KUPCI_IME, KU.PRIIMEK AS KUPCI_PRIIMEK, KU.MANAGER AS KUPCI_MANAGER, KU.VRSTA AS KUPCI_VRSTA, PL.IME AS PLOVILA_IME,
  
  -- Service values
  SV.NETO_DOMACA_VREDNOST,
  SV.NETO_DOMACA_VREDNOST + (SV.NETO_DOMACA_VREDNOST * (NVL(M.DAVEK, 0) / 100)) AS BRUTO_DOMACA_VREDNOST,
  SV.NETO_DOMACA_VREDNOST / (SELECT NVL(LAST_MIDDLE_RATE, 1) FROM V_FOREIGN_RATE) AS NETO_TUJA_VREDNOST,
  (SV.NETO_DOMACA_VREDNOST + (SV.NETO_DOMACA_VREDNOST * (NVL(M.DAVEK, 0) / 100))) / (SELECT NVL(LAST_MIDDLE_RATE, 1) FROM V_FOREIGN_RATE) AS BRUTO_TUJA_VREDNOST
  
	FROM M_STORITVE M
  LEFT OUTER JOIN V_STORITVE_VALUE SV ON SV.ID_STORITVE = M.ID_STORITVE
  LEFT OUTER JOIN M_NNSTOMAR NS ON NS.SIFRA = M.STORITEV
  LEFT OUTER JOIN NNENOTE NNE ON NNE.SIFRA = NS.ENOTA
  LEFT OUTER JOIN M_DE_NA MDN ON MDN.ID_DN = M.ID_DN
  LEFT OUTER JOIN KUPCI KU ON KU.ID = M.ID_LASTNIKA
  LEFT OUTER JOIN PLOVILA PL ON PL.ID = M.ID_PLOVILA
);

CREATE OR REPLACE VIEW V_KUPCI AS (
	SELECT K.ID, K.ID_MEMBER, K.IME, K.PRIIMEK, K.MESTO, K.NASLOV, K.POSTA, K.TELEFON_1, K.TELEFON_2, K.EMAIL, K.YACHT_CLUB_ID, K.TELEX, K.VRSTA, K.NDRZAVA, 
	K.SALDAKONTI_SIT, K.SALDAKONTI_DEM, K.SALDAKONTI_KOM, K.BELEZKA, K.MANAGER,
	NNTIT.INTERNI_OPIS AS NNTITLE_DESC, NNDRZ.INTERNI_OPIS AS NNDRZAVA_DESC, NNDOK.INTERNI_OPIS AS VRSTA_DOKUMENTA_DESC, NNVRS.INTERNI_OPIS AS VRSTA_DESC,
	NNDRZDR.INTERNI_OPIS AS DRZAVA_ROJSTVA_DESC, NNDRZCI.INTERNI_OPIS AS CITIZENSHIP_DESC, NNMAR.INTERNI_OPIS AS MARITAL_STATUS_DESC,
    -- Owner types descriptions
    (SELECT LISTAGG(NV.OPIS,', ') WITHIN GROUP(ORDER BY NV.OPIS ASC) TYPES FROM KUPCI_VRSTA KV, NNVRSKUP NV WHERE NV.SIFRA = KV.VRSTA AND KV.ID_KUPCA = K.ID) AS TYPES_DESCRIPTIONS,
    -- Owner contract data
    (SELECT OBJEKT FROM M_POGODBE M WHERE M.ID_LASTNIKA = K.ID AND M.ID_PLOVILA IS NULL AND ROWNUM = 1 AND M.DATUM_ZACETKA = (SELECT MAX(M2.DATUM_ZACETKA) FROM M_POGODBE M2 WHERE M2.ID_LASTNIKA = K.ID AND M2.ID_PLOVILA IS NULL) ) AS POGODBA_OBJEKT,
    (SELECT N_PRIVEZA FROM M_POGODBE M WHERE M.ID_LASTNIKA = K.ID AND M.ID_PLOVILA IS NULL AND ROWNUM = 1 AND M.DATUM_ZACETKA = (SELECT MAX(M2.DATUM_ZACETKA) FROM M_POGODBE M2 WHERE M2.ID_LASTNIKA = K.ID AND M2.ID_PLOVILA IS NULL) ) AS POGODBA_PRIVEZ
   
	FROM KUPCI K
	LEFT OUTER JOIN NNTITLE NNTIT ON K.NTITLE = NNTIT.SIFRA
	LEFT OUTER JOIN NNDRZAVE NNDRZ ON K.NDRZAVA = NNDRZ.SIFRA
	LEFT OUTER JOIN NNDOKUME NNDOK ON K.VRSTA_DOKUMENTA = NNDOK.SIFRA
	LEFT OUTER JOIN NNVRSKUP NNVRS ON K.VRSTA = NNVRS.SIFRA
	LEFT OUTER JOIN NNDRZAVE NNDRZDR ON K.DRZAVA_ROJSTVA = NNDRZDR.SIFRA
	LEFT OUTER JOIN NNDRZAVE NNDRZCI ON K.CITIZENSHIP = NNDRZCI.SIFRA
	LEFT OUTER JOIN NNMARSTAT NNMAR ON K.MARITAL_STATUS = NNMAR.SIFRA
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1193, SYSDATE, '5.5', 1113, 'Kupci manager CRM')
;