ALTER TABLE ALARM_DATA
ADD ASOCIATED_ID NUMBER
;

ALTER TABLE ALARM_HISTORY
ADD ASOCIATED_ID NUMBER
;

UPDATE ALARM_HISTORY
SET ASOCIATED_ID = TO_NUMBER(ASOCIATED_DATA)
WHERE ASOCIATED_DATA IS NOT NULL AND ASOCIATED_TABLE IN ('KUPCI','PLOVILA','M_POGODBE','NAJAVE')
;

UPDATE ALARM_DATA
SET ASOCIATED_ID = TO_NUMBER(ASOCIATED_DATA)
WHERE ASOCIATED_DATA IS NOT NULL AND ASOCIATED_TABLE IN ('KUPCI','PLOVILA','M_POGODBE','NAJAVE')
;

CREATE OR REPLACE FORCE VIEW V_ALARM_RECEIVE (ID, ID_ALARM_RECIEVE_DET, ID_ALARM_RECIEVE, USER_RECIEVE, DATE_RECIEVE, ID_ALARM, RECIEVE_TYPE, RECIEVE_DATA, RECIEVE_DATA_BEAUTIFIED, SFALARM, SFMODULE, DATUM_KREIRANJA, USER_KREIRANJA, DATUM_ZAPADLOST, SFTRIGGER, USER_MESSAGE, ASOCIATED_TABLE, NNLOCATION_ID, ASOCIATED_DATA, STATUS, DATA_CHECK, UNCONFIRMED, KUPCI_ID, KUPCI_IME, KUPCI_PRIIMEK, KUPCI_ID_MEMBER, KUPCI_NDRZAVA, KUPCI_KODA_JEZIKA, PLOVILA_ID, PLOVILA_IME, OWNER) AS 
  (
SELECT ARD.ID_ALARM_RECIEVE_DET AS ID, ARD.ID_ALARM_RECIEVE_DET, ARD.ID_ALARM_RECIEVE, ARD.USER_RECIEVE, ARD.DATE_RECIEVE, AR.ID_ALARM, AR.RECIEVE_TYPE, AR.RECIEVE_DATA,
REGEXP_REPLACE(AR.RECIEVE_DATA, '^[;]') AS RECIEVE_DATA_BEAUTIFIED,
AD.SFALARM, AD.SFMODULE, AD.DATUM_KREIRANJA, AD.USER_KREIRANJA, AD.DATUM_ZAPADLOST, AD.SFTRIGGER, AD.USER_MESSAGE, AD.ASOCIATED_TABLE, AD.NNLOCATION_ID,
AD.ASOCIATED_DATA, AD.STATUS, AD.DATA_CHECK, (CASE WHEN ARD.DATE_RECIEVE IS NULL THEN 'Y' ELSE 'N' END) AS UNCONFIRMED,
K.ID AS KUPCI_ID, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.ID_MEMBER AS KUPCI_ID_MEMBER, K.NDRZAVA AS KUPCI_NDRZAVA, K.KODA_JEZIKA AS KUPCI_KODA_JEZIKA,
P.ID AS PLOVILA_ID, P.IME AS PLOVILA_IME,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER
FROM ALARM_RECIEVE_DETAIL ARD
INNER JOIN ALARM_RECIEVE AR ON AR.ID_ALARM_RECIEVE = ARD.ID_ALARM_RECIEVE
INNER JOIN ALARM_DATA AD ON AD.ID_ALARM = AR.ID_ALARM
LEFT OUTER JOIN KUPCI K ON K.ID = AD.ASOCIATED_ID AND AD.ASOCIATED_TABLE = 'KUPCI'
LEFT OUTER JOIN PLOVILA P ON P.ID = AD.ASOCIATED_ID AND AD.ASOCIATED_TABLE = 'PLOVILA'
UNION ALL
SELECT ARD.ID_ALARM_RECIEVE_DET AS ID, ARD.ID_ALARM_RECIEVE_DET, ARD.ID_ALARM_RECIEVE, ARD.USER_RECIEVE, ARD.DATE_RECIEVE, AR.ID_ALARM, AR.RECIEVE_TYPE, AR.RECIEVE_DATA,
REGEXP_REPLACE(AR.RECIEVE_DATA, '^[;]') AS RECIEVE_DATA_BEAUTIFIED,
AH.SFALARM, AH.SFMODULE, AH.DATUM_KREIRANJA, AH.USER_KREIRANJA, AH.DATUM_ZAPADLOST, AH.SFTRIGGER, AH.USER_MESSAGE, AH.ASOCIATED_TABLE, AH.NNLOCATION_ID,
AH.ASOCIATED_DATA, AH.STATUS, AH.DATA_CHECK, 'N' AS UNCONFIRMED,
K.ID AS KUPCI_ID, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.ID_MEMBER AS KUPCI_ID_MEMBER, K.NDRZAVA AS KUPCI_NDRZAVA, K.KODA_JEZIKA AS KUPCI_KODA_JEZIKA,
P.ID AS PLOVILA_ID, P.IME AS PLOVILA_IME,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER
FROM ALARM_RECIEVE_DETAIL ARD
INNER JOIN ALARM_RECIEVE AR ON AR.ID_ALARM_RECIEVE = ARD.ID_ALARM_RECIEVE
INNER JOIN ALARM_HISTORY AH ON AH.ID_ALARM = AR.ID_ALARM
LEFT OUTER JOIN KUPCI K ON K.ID = AH.ASOCIATED_ID AND AH.ASOCIATED_TABLE = 'KUPCI'
LEFT OUTER JOIN PLOVILA P ON P.ID = AH.ASOCIATED_ID AND AH.ASOCIATED_TABLE = 'PLOVILA'
)
;

CREATE TABLE FILE_UNZIP (
USERNAME VARCHAR2(100 CHAR) NOT NULL,
FILENAME VARCHAR2(200 CHAR),
FILEDATA BLOB,
CONSTRAINT PK_FILE_UNZIP PRIMARY KEY(USERNAME)
)
;


insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (1433, SYSDATE, '5.5', 1353, 'Alarm')
;