DROP VIEW V_FBMASTER;

CREATE VIEW V_FBMASTER AS
SELECT DISTINCT * FROM (
SELECT P.ID AS IDPLOVILA, P.IME AS PLOVILO, K.ID As IDKUPCA, K.PRIIMEK AS NAZIV, K.IME AS IME, 
K.NASLOV, K.MESTO, K.POSTA, D.OPIS AS DRZAVA, K.TELEFON_1 AS TELEFON, K.EMAIL, K.YACHT_CLUB_ID, 
K.DAVCNA_STEVILKA AS DAVCNA, SK.SIFRA AS VRSTA
FROM 
KUPCI K 
JOIN KUPCI_VRSTA KV ON K.ID=KV.ID_KUPCA
JOIN NNVRSKUP SK ON KV.VRSTA=SK.SIFRA AND SK.TRANSFER_FB='Y'
LEFT OUTER JOIN PLOVILA P ON P.ID_LASTNIKA=K.ID
LEFT OUTER JOIN NNDRZAVE D ON K.NDRZAVA=D.SIFRA
WHERE K.CHECKIN='Y'
UNION ALL

SELECT P.ID AS IDPLOVILA, P.IME AS PLOVILO, K.ID As IDKUPCA, K.PRIIMEK AS NAZIV, K.IME AS IME, 
K.NASLOV, K.MESTO, K.POSTA, D.OPIS AS DRZAVA, K.TELEFON_1 AS TELEFON, K.EMAIL, K.YACHT_CLUB_ID, 
K.DAVCNA_STEVILKA AS DAVCNA,  'ROOM' AS VRSTA
FROM 
KUPCI K 
JOIN REZERVACIJE R ON R.IDKUPCA=K.ID
JOIN PLOVILA P ON R.IDPLOVILA=P.ID
LEFT OUTER JOIN NNDRZAVE D ON K.NDRZAVA=D.SIFRA
WHERE P.BOOKING='R' AND K.CHECKIN='Y' AND (R.DATUM_DO > Sysdate-30)
);


GRANT SELECT ON V_FBMASTER TO FBMASTER;
GRANT SELECT,INSERT ON INTERFACE_SERVICES TO FBMASTER;

CREATE TABLE M_NNSTOMAR_DAVEK (
ID_NNSTOMAR_DAVEK NUMBER NOT NULL,
STORITEV VARCHAR2(6 CHAR) NOT NULL,
ID_DAVEK NUMBER NOT NULL,
STOPNJA NUMBER NOT NULL,
CONSTRAINT PK_M_NNSTOMAR_DAVEK PRIMARY KEY (ID_NNSTOMAR_DAVEK));

CREATE SEQUENCE M_NNSTOMAR_DAVEK_SEQ START WITH 1 INCREMENT BY 1;

INSERT INTO MARINA_SEQUENCES (TABLENAME, FIELDNAME, SEQUENCE_NAME, COUNTER_TYPE)
VALUES
('M_NNSTOMAR_DAVEK', 'ID_NNSTOMAR_DAVEK', 'M_NNSTOMAR_DAVEK_SEQ', 'S_KLJUCI');

Insert into DATA_KEYS (IZVOR_TABELA,IZVOR_POLJE,IME_TABELE,IME_POLJA,TIP_POLJA,POLJE_OPIS,TIP_OPIS) 
values 
('M_NNSTOMAR_DAVEK','STORITEV','M_NNSTOMAR','SIFRA','S','OPIS','S');

Insert into DATA_KEYS (IZVOR_TABELA,IZVOR_POLJE,IME_TABELE,IME_POLJA,TIP_POLJA,POLJE_OPIS,TIP_OPIS) 
values 
('M_NNSTOMAR_DAVEK','ID_DAVEK','S_DAVEK','ID_DAVEK','I','OPIS','S');

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (264, SYSDATE, '5.5', 184, 'Kombinirani davek');